unit ufrmM3205;

(*
                M3205 - ufrmM3205
       (c) 2005 Paul C. L. Willmott, VP9MU

 This program is free software; you can redistribute it
 and/or modify it under the terms of the GNU General
 Public License as published by the Free Software
 Foundation; either version 2 of the License, or at
 your option, any later version.

 This program is distributed in the hope that it will
 be useful, but WITHOUT ANY WARRANTY; without even the
 implied warranty of MERCHANTABILITY or FITNESS FOR A
 PARTICULAR PURPOSE.  See the GNU General Public
 License for more details.

 You should have received a copy of the GNU General
 Public License along with this program; if not, write
 to the Free Software Foundation, Inc., 59 Temple
 Place, Suite 330, Boston, MA  02111-1307  USA

        Contact : pwillmott@northrock.bm
*)

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, StdCtrls,  ComCtrls, SyncObjs ;

const
  kHighestAddress : Cardinal = $1FFFF ;
  kBackColour = clNavy ;
  kForeColour = clWhite ;

type

  T2Byte = packed record
    a , b : byte ;
  end ;

  T4Byte = packed record
    a , b , c , d : byte ;
  end ;

  T2Cardinal = packed record
    a , b : Cardinal ;
  end ;

  TfrmM3205 = class(TForm)
    mnuMainMenu: TMainMenu;
    mnuFile: TMenuItem;
    mnuExit: TMenuItem;
    mnuTools: TMenuItem;
    mnuBuildIPS32X: TMenuItem;
    mnuHelp: TMenuItem;
    mnuAbout: TMenuItem;
    mnuStart: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    mnuOptions: TMenuItem;
    tmrStart: TTimer;
    imgTVScreen: TImage;
    procedure mnuExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mnuBuildIPS32XClick(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mnuAboutClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure mnuStartClick(Sender: TObject);
    procedure mnuOptionsClick(Sender: TObject);
    procedure tmrStartTimer(Sender: TObject);

  private

//  Emulator Workspace

    iMemorySpace : array of byte ;

    iPPC          : Cardinal     ; // Pseudo-PC (Program Counter)
    iHP           : Cardinal     ; // Header Pointer
    iCPC          : Cardinal     ; // Code Program Counter - PC address in a
                                   // real system !
    iLOADPOINTER  : Cardinal     ; // Pointer to Next Address to Place File
                                   // Input
    iINPUTPOINTER : Cardinal     ; // Pointer to Next Address to Place Keyboard
                                   // Input
    pTextFile     : file of char ; // File handle for READ Disk Operations
    bIsOpen       : boolean      ; // True iff READ file is open
    iPSP          : Cardinal     ; // Parameter Stack Pointer
    iRSP          : Cardinal     ; // Return Stack Pointer
    bInsertON     : boolean      ; // TRUE=Keyboard Insert Mode, FALSE=Keyboard
                                   // Overwrite Mode
    bOKToStop     : boolean      ;

    KBufCount : byte ;
    KBuf : array[$00..$ff] of word ;
    KBufNext : byte ;
    KBufRead : byte ;

    _20msCount  : Cardinal ;
    bIsRunning  : boolean ;

{
    The JumpTable is an array of IPS primative procedures. Space is
    allocated for 256 primatives, though not all are used. The unused
    ones are initialized to a dummy procedure by ReloadKernal.
}

    pJumpTable : array[$00..$ff] of procedure of object ;
    FKernelFilename: string;
    FForceClock: boolean;
    FDo20msInterval: Cardinal;
    FUTCOffset: double;
    FUseDVFLAG: boolean;

    procedure DrawTVScreen ;
    procedure DrawChar(iAddress:Cardinal) ;

    function PeekByte(iAddress:Cardinal):byte ;
    function PeekWord(iAddress:Cardinal):word ;
    function PeekInteger(iAddress:Cardinal):integer ;
    function PeekCardinal(iAddress:Cardinal):Cardinal ;

    procedure PokeByte(iAddress:Cardinal;iValue:byte) ;
    procedure PokeWord(iAddress:Cardinal;iValue:word) ;
    procedure PokeInteger(iAddress:Cardinal;iValue:integer) ;
    procedure PokeCardinal(iAddress:Cardinal;iValue:Cardinal) ;

    procedure PushInteger(iValue:integer) ;
    procedure PushCardinal(iValue:Cardinal) ;

    function PopInteger:integer ;
    function PopCardinal:Cardinal ;

    procedure PushRSCardinal(iValue:Cardinal) ;
    function PopRSCardinal:Cardinal ;

    procedure Add64(N,M:Int64;var R:Int64) ;
    procedure Subtract64(N,M:Int64;var R:Int64) ;
    function Compare64(N,M:Int64):integer ;

    procedure code_rumpelstilzchen ;
    procedure code_defex ;
    procedure code_consex ;
    procedure code_varex ;
    procedure code_retex ;
    procedure code_get ;
    procedure code_getB ;
    procedure code_put ;
    procedure code_putB ;
    procedure code_blit_4 ;
    procedure code_bronz ;
    procedure code_jump ;
    procedure code_weg ;
    procedure code_pweg ;
    procedure code_plus ;
    procedure code_minus ;
    procedure code_dup ;
    procedure code_pdup ;
    procedure code_vert ;
    procedure code_zwo ;
    procedure code_rdu ;
    procedure code_rdo ;
    procedure code_index ;
    procedure code_s_to_r ;
    procedure code_r_to_s ;
    procedure code_eqz ;
    procedure code_gz ;
    procedure code_lz ;
    procedure code_geu ;
    procedure code_f_vergl ;
    procedure code_nicht ;
    procedure code_und ;
    procedure code_oder ;
    procedure code_exo ;
    procedure code_bit ;
    procedure code_cbit ;
    procedure code_sbit ;
    procedure code_tbit ;
    procedure code_jeex ;
    procedure code_loopex ;
    procedure code_plusloopex ;
    procedure code_field_trans ;
    procedure code_pmul ;
    procedure code_pdiv ;
    procedure code__polyname ;
    procedure code__scode ;
    procedure code__cscan ;
    procedure code_chs ;
    procedure code_cyc2 ;
    procedure code_closefile ;
    procedure code_openfile ;
    procedure code_loadcode ;
    procedure code_savecode ;
    procedure code_setkbptr ;
    procedure code_getPS ;
    procedure code_setPS ;
    procedure code_pplus ;
    procedure code_pminus ;
    procedure code_rp_loop ;
    procedure code_tr_loop ;
    procedure code_swap3 ;
    procedure code_plus_store ;

    function PopStr:string ;

    procedure code_StopWatch(StopWatchAddress:Cardinal) ;
    procedure code_uhr ;
    procedure code_ipptrcheck ;
    procedure code_keyb ;
    procedure code_file_in ;

    procedure DumpMemory ;
    function KeyWaiting : boolean ;
    function ReadKey : word ;
    procedure Execute ;
    procedure SetKernelFilename(const Value: string);
    procedure SetDo20msInterval(const Value: Cardinal);
    procedure SetForceClock(const Value: boolean);
    procedure SetUTCOffset(const Value: double);
    procedure SetUseDVFLAG(const Value: boolean);

  public

    procedure SaveSettings ;
    property KernelFilename : string  read FKernelFilename write SetKernelFilename;
    property ForceClock : boolean  read FForceClock write SetForceClock;
    property Do20msInterval : Cardinal  read FDo20msInterval write SetDo20msInterval;
    property UTCOffset : double  read FUTCOffset write SetUTCOffset;
    property UseDVFLAG : boolean  read FUseDVFLAG write SetUseDVFLAG;
  public
    { Public declarations }
  end;

var
  frmM3205: TfrmM3205;

implementation

uses ufrmIPSXBuilder, INIFiles , ufrmAbout, ufrmOptions, Math, DateUtils ;

{$R *.dfm}

{
  Data Types
  ----------

  Integer   = Signed 32 bit Integer
  Cardinal  = Unsigned 32 bit Integer
  Byte      = Unsigned 8 bit Integer
  Int64     = Signed 64-bit Integer
}

const

{
------------------------------
IPS32-M Fixed Memory Addresses
------------------------------

000 - 3FF TV Screen

Syspage assignments 400-47F
---------------------------
400  ' COMPILER
401
402
403
404  0 ' ZEIG-STAPEL (KETTE)
405
406
407
408  1
409                                  
40A
40B
40C  2
40D
40E
40F
410  3
411
412
413
414  4
415
416
417
418  5                               
419                                  
41A
41B
41C  6
41D
41E
41F
420  7
421
422
423
424  JUMP
425
426
427
428  #00000400
429
42A
42B
42C  READYFLAG
42D  -
42E  -
42F  -
430  $PE value
431
432
433
434  $PI value
435
436
437
438  $P2 value
439
43A
43B
43C  $P3 value
43D
43E
43F
440  DVFLAG
441
442
443
444  LOADFLAG
445  -
446  -
447  -
448  UHR 10ms    (0-98)
449  UHR Seconds (0-59)
44A  UHR Minutes (0-59)
44B  UHR Hours   (0-23)
44C  UHR Days LSW
44D  UHR Days MSW
44E  -
44F  -
450  SU0 10ms    (0-98)
451  SU0 Seconds (0-59)
452  SU0 Minutes LSW
453  SU0 Minutes MSW
454  SU1 10ms    (0-98)
455  SU1 Seconds (0-59)
456  SU1 Minutes LSW
457  SU1 Minutes MSW
458  SU2 10ms    (0-98)
459  SU2 Seconds (0-59)
45A  SU2 Minutes LSW
45B  SU2 Minutes MSW
45C  SU3 10ms    (0-98)
45D  SU3 Seconds (0-59)
45E  SU3 Minutes LSW
45F  SU3 Minutes MSW
460  $ND
461
462
463
464  $SIZE Value
465
466
467
468  $Os value (IPSX-32)
469
46A
46B

Return Stack
------------


5F0 IPS Return Stack base
5F1  (Stack underflow)
5F2		v
5F3		v
5F4		v
5F5		v
5F6		v
5F7		v
5F8		v
5F9		v
5FA		v
5FB		v
5FC		v
5FD		v
5FE		v
5FF (Underflow max 4 items)

600   IPS begins here (RUMPELSTILZCHEN)

-------------------------------
Paul Willmott March 21, 2005
}

  kSYSPAGE   = $400 ; { Start of SYSPAGE <- COMPILER / COMPILER/R }
  kKETTE     = $404 ; { CHAIN }
  kREADYFLAG = $42C ; { Compiler free to process input }
  kPE        = $430 ; { Pointer to end of input }
  kPI        = $434 ; { Compiler Read Pointer }
  kP2        = $438 ; { End of Block reached Flag }
  kP3        = $43C ; { Link pointer for $scode }
  kDVFLAG    = $440 ; { to indicate need to update video }
  kLOADFLAG  = $444 ; { Input Coming From File }
  kUHR       = $448 ; { UHR 10ms }
  kSU0       = $450 ; { Stopwatch 0 }
  kSU1       = $454 ; { Stopwatch 1 }
  kSU2       = $458 ; { Stopwatch 2 }
  kSU3       = $45C ; { Stopwatch 3 }
  kND        = $460 ; { $ND }
  kSIZE      = $464 ; { $SIZE }
  kTV0       = $000 ; { 1st   TV Screen line position }
  kTV4       = $100 ; { 4th   TV Screen line position }
  kSYSLINE   = $1C0 ; { Position Buffer for messages  }
  kTV8       = $200 ; { 8th   TV Screen line position }
  kTVE       = $3FF ; { Last  TV Screen line position }
  k_Os       = $468 ; { Link offset for IPS-X }
  kH         = $444 ; { Pointer to 1st Free Memory Position }

  kRETURNSTACK = $5F0 ; { Start of Return Stack    }

//  Virtual Machine Op Codes
//  ------------------------

  ips_return = $0        ; { RUMPELSTILZCHEN    }
  ips_defex = $1         ; { DEFEX              }
  ips_consex = $2        ; { CONSEX             }
  ips_varex = $3         ; { VAREX              }
  ips_retex = $4         ; { RETEX              }
  ips_get = $5           ; { @                  }
  ips_getB = $6          ; { @B                 }
  ips_put = $7           ; { !                  }
  ips_putB = $8          ; { !B                 }
  ips_plus_store = $9    ; { +!                 }
  ips_blit_4 = $A        ; { 4BLITERAL          }
  ips_bronz = $B         ; { BRONZ              }
  ips_jump = $C          ; { JUMP               }
  ips_weg = $D           ; { WEG                }
  ips_pweg = $E          ; { PWEG               }
  ips_plus = $F          ; { +                  }
  ips_minus = $10        ; { -                  }
  ips_dup = $11          ; { DUP                }
  ips_pdup = $12         ; { PDUP               }
  ips_vert = $13         ; { VERT               }
  ips_zwo = $14          ; { ZWO                }
  ips_rdu = $15          ; { RDU                }
  ips_rdo = $16          ; { RDO                }
  ips_index = $17        ; { I                  }
  ips_s_to_r = $18       ; { S>R                }
  ips_r_to_s = $19       ; { R>S                }
  ips_eqz = $1A          ; { =0                 }
  ips_gz = $1B           ; { >0                 }
  ips_lz = $1C           ; { <0                 }
  ips_geu = $1D          ; { >=U                }
  ips_f_vergl = $1E      ; { F-VERGL            }
  ips_nicht = $1F        ; { NICHT              }
  ips_und = $20          ; { UND                }
  ips_oder = $21         ; { ODER               }
  ips_exo = $22          ; { EXO                }
  ips_bit = $23          ; { BIT                }
  ips_cbit = $24         ; { CBIT               }
  ips_sbit = $25         ; { SBIT               }
  ips_tbit = $26         ; { TBIT               }
  ips_jeex = $27         ; { $JEEX              }
  ips_loopex = $28       ; { LOOPEX             }
  ips_plusloopex = $29   ; { +LOOPEX            }
  ips_field_trans = $2A  ; { >>>                }
  ips_pmul = $2B         ; { P*                 }
  ips_pdiv = $2C         ; { P/MOD              }
  ips__polyname = $2E    ; { $POLYNAME          }
  ips__scode = $2F       ; { $SCODE             }
  ips__cscan = $30       ; { $CSCAN             }
  ips_chs = $31          ; { CHS                }
  ips_cyc2 = $32         ; { CYC2               }
  ips_closefile = $33    ; { $CLOSEFILE         }
  ips_openfile = $34     ; { $OPENFILE          }
  ips_loadcode = $36     ; { $LOADCODE          }
  ips_savecode = $37     ; { $SAVECODE          }
  ips_setkbptr = $38     ; { $IPSETZEN          }
  ips_getPS = $39        ; { $PSHOLEN           }
  ips_setPS = $3A        ; { $PSSETZEN          }
  ips_rp_loop = $3B      ; { RP-LOOP            }
  ips_tr_loop = $3C      ; { TR-LOOP            }
  ips_swap3 = $3D        ; { 3V3                }
  ips_pplus = $3F        ; { P+                 }
  ips_pminus = $40       ; { P-                 }

procedure TfrmM3205.mnuExitClick(Sender: TObject);
begin
  bOKToStop := true ;
  Self.Close ;
end;

procedure TfrmM3205.FormCreate(Sender: TObject);
var
  pINIFile : TINIFile ;

begin

  pINIFile := TIniFile.Create( ChangeFileExt( Application.ExeName, '.INI' ) );
  try
    KernelFilename := pINIFile.ReadString( 'M3205', 'Kernel Filename', ExtractFilePath(Application.ExeName)+'IPS32-M.BIN');
    ForceClock     := pINIFile.ReadBool( 'M3205', 'Force Clock', true );
    UseDVFLAG      := pINIFile.ReadBool( 'M3205', 'Use DVFLAG', true );
    Do20msInterval := pINIFile.ReadInteger( 'M3205', '20ms Interval', 34500 );
    UTCOffset := pINIFile.ReadFloat( 'M3205', 'UTC Offset', -4.0 );
  finally
    pIniFile.Free;
  end;

  bIsRunning := false ;

end;

function TfrmM3205.KeyWaiting: boolean;
begin
  result := KBufCount <> 0 ;
end;

function TfrmM3205.ReadKey: word;
begin
  result := KBuf[KBufRead] ;
  KBufRead := kBufRead + 1 ;
  KBufCount := KBufCount - 1 ;
end;

procedure TfrmM3205.mnuBuildIPS32XClick(Sender: TObject);
begin
  if frmIPSXBuilder = nil then frmIPSXBuilder := TfrmIPSXBuilder.Create(Self) ;
  frmIPSXBuilder.ShowModal ;
end;

procedure TfrmM3205.SaveSettings;
var
  pINIFile : TINIFile ;
begin
  pINIFile := TIniFile.Create( ChangeFileExt( Application.ExeName, '.INI' ) );
  try
    pINIFile.WriteString( 'M3205', 'Kernel Filename', KernelFilename);
    pINIFile.WriteBool( 'M3205', 'Force Clock', ForceClock);
    pINIFile.WriteBool( 'M3205', 'Use DVFLAG', UseDVFLAG);
    pINIFile.WriteInteger( 'M3205', '20ms Interval', Do20msInterval);
    pINIFile.WriteFloat( 'M3205', 'UTC Offset', UTCOffset);
    pINIFile.UpdateFile ;
  finally
    pIniFile.Free;
  end;
end;

procedure TfrmM3205.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  wKey : word ;

const
  VirtualKeys : array[0..255,false..true] of word = (
   (0,0), // 00 UnAssigned
   (0,0), // 01 UnAssigned
   (0,0), // 02 UnAssigned
   (0,0), // 03 UnAssigned
   (0,0), // 04 UnAssigned
   (0,0), // 05 Unassigned
   (0,0), // 06 Unassigned
   (0,0), // 07 Unassigned
   (0,0), // 08 BS
   (0,0), // 09 HT
   (0,0), // 0a Unassigned
   (0,0), // 0b UnAssigned
   (0,0), // 0c UnAssigned
   (0,0), // 0d CR
   (0,0), // 0e UnAssigned
   (0,0), // 0f Unassigned
   (0,0), // 10 Unassigned
   (0,0), // 11 Unassigned
   (0,0), // 12 Unassigned
   (0,0), // 13 Unassigned
   (0,0), // 14 Unassigned
   (0,0), // 15 UnAssigned
   (0,0), // 16 UnAssigned
   (0,0), // 17 UnAssigned
   (0,0), // 18 UnAssigned
   (0,0), // 19 Unassigned
   (0,0), // 1a Unassigned
   (0,0), // 1b ESC
   (0,0), // 1c Unassigned
   (0,0), // 1d Unassigned
   (0,0), // 1e Unassigned
   (0,0), // 1f UnAssigned
   (0,0), // 20 SPC
   (0,0), // 21 UnAssigned
   (0,0), // 22 UnAssigned
   ($ff05,$ff05), // 23 <END>
   ($ff01,$ff01), // 24 <HOME>
   ($ff03,$ff03), // 25 <LEFT>
   ($ff02,$ff02), // 26 <UP>
   ($ff04,$ff04), // 27 <RIGHT>
   ($ff06,$ff06), // 28 <DOWN>
   (0,0), // 29 UnAssigned
   (0,0), // 2a UnAssigned
   (0,0), // 2b UnAssigned
   (0,0), // 2c UnAssigned
   ($ff07,$ff07), // 2d <INSERT>
   ($ff08,$ff08), // 2e <DELETE>
   (0,0), // 2f Unassigned
   (0,0), // 30 '0', ')'
   (0,0), // 31 '1', '!'
   (0,0), // 32 '2', '@'
   (0,0), // 33 '3', '#'
   (0,0), // 34 '4', '$'
   (0,0), // 35 '5', '%'
   (0,0), // 36 '6', '^'
   (0,0), // 37 '7', '&'
   (0,0), // 38 '8', '*'
   (0,0), // 39 '9', '('
   (0,0), // 3a Unassigned
   (0,0), // 3b Unassigned
   (0,0), // 3c Unassigned
   (0,0), // 3d UnAssigned
   (0,0), // 3e UnAssigned
   (0,0), // 3f UnAssigned
   (0,0), // 40 UnAssigned
   (0,0), // 41 'a', 'A'
   (0,0), // 42 'b', 'B'
   (0,0), // 43 'c', 'C'
   (0,0), // 44 'd', 'D'
   (0,0), // 45 'e', 'E'
   (0,0), // 46 'f', 'F'
   (0,0), // 47 'g', 'G'
   (0,0), // 48 'h', 'H'
   (0,0), // 49 'i', 'I'
   (0,0), // 4a 'j', 'J'
   (0,0), // 4b 'k', 'K'
   (0,0), // 4c 'l', 'L'
   (0,0), // 4d 'm', 'M'
   (0,0), // 4e 'n', 'N'
   (0,0), // 4f 'o', 'O'
   (0,0), // 50 'p', 'P'
   (0,0), // 51 'q', 'Q'
   (0,0), // 52 'r', 'R'
   (0,0), // 53 's', 'S'
   (0,0), // 54 't', 'T'
   (0,0), // 55 'u', 'U'
   (0,0), // 56 'v', 'V'
   (0,0), // 57 'w', 'W'
   (0,0), // 58 'x', 'X'
   (0,0), // 59 'y', 'Y'
   (0,0), // 5a 'z', 'Z'
   (0,0), // 5b UnAssigned
   (0,0), // 5c UnAssigned
   (0,0), // 5d UnAssigned
   (0,0), // 5e UnAssigned
   (0,0), // 5f Unassigned
   (0,0), // 60 '0' Keypad
   (0,0), // 61 '1'
   (0,0), // 62 '2'
   (0,0), // 63 '3'
   (0,0), // 64 '4'
   (0,0), // 65 '5'
   (0,0), // 66 '6'
   (0,0), // 67 '7'
   (0,0), // 68 '8'
   (0,0), // 69 '9'
   (0,0), // 6a '*'
   (0,0), // 6b '+'
   (0,0), // 6c Unassigned
   (0,0), // 6d '-'
   (0,0), // 6e Unassigned
   (0,0), // 6f '/'
   (0,0), // 70 UnAssigned
   (0,0), // 71 UnAssigned
   (0,0), // 72 UnAssigned
   (0,0), // 73 Unassigned
   (0,0), // 74 Unassigned
   (0,0), // 75 Unassigned
   (0,0), // 76 Unassigned
   (0,0), // 77 Unassigned
   (0,0), // 78 Unassigned
   (0,0), // 79 UnAssigned
   (0,0), // 7a UnAssigned
   (0,0), // 7b UnAssigned
   (0,0), // 7c UnAssigned
   (0,0), // 7d Unassigned
   (0,0), // 7e Unassigned
   (0,0), // 7f Unassigned
   (0,0), // 80 UnAssigned
   (0,0), // 81 UnAssigned
   (0,0), // 82 UnAssigned
   (0,0), // 83 UnAssigned
   (0,0), // 84 UnAssigned
   (0,0), // 85 Unassigned
   (0,0), // 86 Unassigned
   (0,0), // 87 Unassigned
   (0,0), // 88 Unassigned
   (0,0), // 89 Unassigned
   (0,0), // 8a Unassigned
   (0,0), // 8b UnAssigned
   (0,0), // 8c UnAssigned
   (0,0), // 8d UnAssigned
   (0,0), // 8e UnAssigned
   (0,0), // 8f Unassigned
   (0,0), // 90 Unassigned
   (0,0), // 91 Unassigned
   (0,0), // 92 Unassigned
   (0,0), // 93 Unassigned
   (0,0), // 94 Unassigned
   (0,0), // 95 UnAssigned
   (0,0), // 96 UnAssigned
   (0,0), // 97 UnAssigned
   (0,0), // 98 UnAssigned
   (0,0), // 99 Unassigned
   (0,0), // 9a Unassigned
   (0,0), // 9b Unassigned
   (0,0), // 9c Unassigned
   (0,0), // 9d Unassigned
   (0,0), // 9e Unassigned
   (0,0), // 9f UnAssigned
   (0,0), // a0 UnAssigned
   (0,0), // a1 UnAssigned
   (0,0), // a2 UnAssigned
   (0,0), // a3 Unassigned
   (0,0), // a4 Unassigned
   (0,0), // a5 Unassigned
   (0,0), // a6 Unassigned
   (0,0), // a7 Unassigned
   (0,0), // a8 Unassigned
   (0,0), // a9 UnAssigned
   (0,0), // aa UnAssigned
   (0,0), // ab UnAssigned
   (0,0), // ac UnAssigned
   (0,0), // ad Unassigned
   (0,0), // ae Unassigned
   (0,0), // af Unassigned
   (0,0), // b0 Unassigned
   (0,0), // b1 Unassigned
   (0,0), // b2 Unassigned
   (0,0), // b3 UnAssigned
   (0,0), // b4 UnAssigned
   (0,0), // b5 UnAssigned
   (0,0), // b6 UnAssigned
   (0,0), // b7 Unassigned
   (0,0), // b8 Unassigned
   (0,0), // b9 Unassigned
   (0,0), // ba ';', ':'
   (0,0), // bb '=', '+'
   (0,0), // bc ',', '<'
   (0,0), // bd '-', '_'
   (0,0), // be '.', '>'
   (0,0), // bf '/', '?'
   (0,0), // c0 '`', '~'
   (0,0), // c1 Unassigned
   (0,0), // c2 Unassigned
   (0,0), // c3 Unassigned
   (0,0), // c4 Unassigned
   (0,0), // c5 Unassigned
   (0,0), // c6 Unassigned
   (0,0), // c7 UnAssigned
   (0,0), // c8 UnAssigned
   (0,0), // c9 UnAssigned
   (0,0), // ca UnAssigned
   (0,0), // cb Unassigned
   (0,0), // cc Unassigned
   (0,0), // cd Unassigned
   (0,0), // ce Unassigned
   (0,0), // cf Unassigned
   (0,0), // d0 Unassigned
   (0,0), // d1 UnAssigned
   (0,0), // d2 UnAssigned
   (0,0), // d3 UnAssigned
   (0,0), // d4 UnAssigned
   (0,0), // d5 Unassigned
   (0,0), // d6 Unassigned
   (0,0), // d7 Unassigned
   (0,0), // d8 Unassigned
   (0,0), // d9 Unassigned
   (0,0), // da Unassigned
   (0,0), // db '[', '{'
   (0,0), // dc '\', '|'
   (0,0), // dd ']', '}'
   (0,0), // de ''', '"'
   (0,0), // df Unassigned
   (0,0), // e0 Unassigned
   (0,0), // e1 Unassigned
   (0,0), // e2 Unassigned
   (0,0), // e3 Unassigned
   (0,0), // e4 Unassigned
   (0,0), // e5 UnAssigned
   (0,0), // e6 UnAssigned
   (0,0), // e7 UnAssigned
   (0,0), // e8 UnAssigned
   (0,0), // e9 Unassigned
   (0,0), // ea Unassigned
   (0,0), // eb Unassigned
   (0,0), // ec Unassigned
   (0,0), // ed Unassigned
   (0,0), // ee Unassigned
   (0,0), // ef UnAssigned
   (0,0), // f0 UnAssigned
   (0,0), // f1 UnAssigned
   (0,0), // f2 UnAssigned
   (0,0), // f3 Unassigned
   (0,0), // f4 Unassigned
   (0,0), // f5 Unassigned
   (0,0), // f6 Unassigned
   (0,0), // f7 Unassigned
   (0,0), // f8 Unassigned
   (0,0), // f9 UnAssigned
   (0,0), // fa UnAssigned
   (0,0), // fb UnAssigned
   (0,0), // fc UnAssigned
   (0,0), // fd Unassigned
   (0,0), // fe Unassigned
   (0,0)) // ff Unassigned
   ;

begin
  wKey := VirtualKeys[Lo(Key),ssShift in Shift] ;
  if (wKey<>0) then begin
    KBuf[KBufNext] := wKey ;
    KBufCount := KBufCount + 1 ;
    KBufNext := KBufNext + 1 ;
  end ;
end;

procedure TfrmM3205.mnuAboutClick(Sender: TObject);
begin
  if frmAbout = nil then frmAbout := TfrmAbout.Create(Self) ;
  frmAbout.ShowModal ;
end;

procedure TfrmM3205.FormKeyPress(Sender: TObject; var Key: Char);
begin
  KBuf[KBufNext] := BYTE(Key) ;
  KBufCount := KBufCount + 1 ;
  KBufNext := KBufNext + 1 ;
end;

procedure TfrmM3205.Add64(N, M: Int64; var R: Int64);

{
     Add64 - Adds 2 unsigned 64 bit d-words (N & M) to
     form Unsigned 64 bit result (R).
}

var
  _N : packed array[0..7] of byte absolute N ;
  _M : packed array[0..7] of byte absolute M ;
  _R : packed array[0..7] of byte absolute R ;
  A  : byte ;
  B  : word ;
  C  : word ; { Carry }
begin
  R := 0 ;
  C := 0 ;
  for A := 0 to 7 do begin
    B := _N[A] + _M[A] + C ;
    _R[A] := B and $ff ;
    C := B shr 8 ;
  end ;
end ; { Add64 }

procedure TfrmM3205.code__cscan;
(*
$CSCAN Scan input buffer for separators/non-separators
-------------------------------------------------------
There are only two calls to this, both from $NAME
The first has entry flag =1, and causes scan to first
non-separator

The 2nd has entry flag =2 which scans to next separator.
Thus a found word is bracketed by $P1 Start byte and $PI
where $PI is the Index pointer.

Entry = 1
---------
Scan until valid character found
Returns >0 if valid character found
0 if invalid character
$P1 = $PI init by $NAME when valid char found
$P2 = 1 if if end of buffer found i.e. $PI=$PE

Entry = 2
---------
Scan until separator found
Returns n1 which can be discarded ???
n2 which can be discarded ???
$P1 and $PI-1 identifies word string

Separator = space { } <eob>
Valid character = NOT [ the above or anything inside { } ]
*)

const
  cflag : boolean = false ;

var
  _PI, _PE, I : Cardinal ;
  J, K, C : byte ;

begin

  PushCardinal(0) ;
  _PI := PeekCardinal(kPI) ;
  _PE := PeekCardinal(kPE) ;
  I := _PI ;
  while (I<=_PE) do begin
    Inc(iPSP,4) ;
    PushCardinal(1) ;
    C := PeekByte(I) ;
    if (C<>$20) then begin
      if (cflag) then begin
        if (C=$29) then begin
          cflag := false ;
        end ;
      end
      else begin
        if (C=$28) then begin
          cflag := true ;
        end
        else begin
          Inc(iPSP,4) ;
          PushCardinal(2) ;
        end ;
      end ;
    end ;
    J := PopCardinal ;
    K := PopCardinal ;
    PushCardinal(J) ;
    if (J=K) then begin
      PushCardinal(0) ;
    end
    else begin
      PokeCardinal(kPI,I) ;
      I := _PE ;
    end ;
    Inc(I) ;
  end ;

  if (PeekCardinal(iPSP)=0) then begin
    PokeCardinal(kPI,Succ(PeekCardinal(kPE))) ;
    J := PopCardinal ;
    K := PopCardinal ;
    PushCardinal(J) ;
    PokeCardinal(kP2,1) ;
  end ;

end ; { code__cscan }

procedure TfrmM3205.code__polyname;

var
  D : Cardinal ;
  X : Cardinal ;
  P : Cardinal ;

begin

  D := PopCardinal ;      { character }
  X := PopCardinal shr 8 ; // #57CE8D00
  P := D xor X xor (X shr 1) xor (X shr 2) xor (X shr 7) ;
  T4Byte(X).d := T4Byte(P).a ;
  X := X shr 7 ;
  X := X shl 8 ;

  PushCardinal(X) ;

end ; { code__polyname }

procedure TfrmM3205.code__scode;

{
  Looks through linked list until name found
  ------------------------------------------
  Return address of a word. 0 if not found
  $P3 points to SYS PAGE loc. holding initial link pointer
  $ND contains the 4-byte hashed name
}

var
  D, N, Os, Q : Cardinal ;

begin

  N  := PeekCardinal(kND) ;
  Os := PeekCardinal(k_Os) ;
  D  := PeekCardinal(kP3) + Os ; { Link value }

  Q  := PeekCardinal(D) and $ffffff3f ;
  while (D<>Os) and (Q<>N) do begin
    D := PeekCardinal(D + 4) + Os ;
    Q := PeekCardinal(D) and $ffffff3f ;
  end ;

  if (Q = N) then begin
    PushCardinal(D+8) ;
  end
  else begin
    PushCardinal(0) ;
  end ;

end ; { code__scode }

procedure TfrmM3205.code_bit;
{
     BIT     Set mask for bit of word specified. Mask is all zeroes
             with bit specified set to 1.
     <n> BIT
     <mask, only 1 bit set to 1>
}

begin
  PushCardinal(1 shl PopCardinal) ;
end ; { code_bit }

procedure TfrmM3205.code_blit_4;

{
     4BLITERAL   within programs pushes the number (4 bytes) following it on to
                 the stack. The pseudo-PC is incremented beyond these 4 bytes.
}

begin
  PushCardinal(PeekCardinal(iPPC)) ;
  iPPC := iPPC + 4 ;
end ; { code_blit_4 }

procedure TfrmM3205.code_bronz;

{
     BRONZ       branches on finding a 0 (even number) to the address following it
                 in the program. If it found an odd number, it increments the
                 pseudo-PC beyond the address.
}

begin
  if ((PopCardinal and $1) = 0) then begin
    iPPC := PeekCardinal(iPPC) ;
  end
  else begin
    iPPC := iPPC + 4 ;
  end ;
end ; { code_bronz }

procedure TfrmM3205.code_cbit;
{
     CBIT    Clear bit of byte.
     <bit-no> <addr of byte> CBIT
     Bit specified set to 0, all other bits unaffected.
}

var
  iMemAddr : Cardinal ;

begin
  iMemAddr := PopCardinal ;
  PokeByte(iMemAddr, PeekByte(iMemAddr) and t4Byte(not (1 shl PopCardinal)).a) ;
end ; { code_cbit }

procedure TfrmM3205.code_chs;

{
     CHS     changes the sign of the item on the stack
     <n> CHS
     <-n>
}

begin
  PushInteger(-PopInteger) ;
end ; { code_chs }

procedure TfrmM3205.code_closefile;
{
     $CLOSEFILE - takes no parameters, does just what it says.

     REFERENCE: James R. Miller, Private Communication, December 18, 2000.
}

begin
  if (bIsOpen) then begin
    CloseFile(pTextFile) ;
    bIsOpen := false ;
  end ;
end ; { code_closefile }

procedure TfrmM3205.code_consex;
begin
  PushCardinal(PeekCardinal(iHP)) ;
end ; { code_consex }

procedure TfrmM3205.code_defex;
begin
  PushRSCardinal(iPPC) ;
  iPPC := iHP ;
end ; { code_defex }

procedure TfrmM3205.code_dup;

{
      DUP     Duplicate stack.
     <n> DUP
     <n> <n>
}

begin
  PushCardinal(PeekCardinal(iPSP)) ;
end ; { code_dup }

procedure TfrmM3205.code_eqz;

{
     =0      Tests for zero.
     <n> =0
     <TRUE IF n=0>
}

begin
  if (PeekInteger(iPSP)=0) then begin
    PokeCardinal(iPSP,1) ;
  end
  else begin
    PokeCardinal(iPSP,0) ;
  end ;
end ; { code_eqz }

procedure TfrmM3205.code_exo;
{
     EXO    Logically Exclusive-ORs all bits
     <n> <m> EXO
     <n exclusive-OR m, bitwise>
}

var
  M : Cardinal ;
begin
  M := PopCardinal ;
  PokeCardinal(iPSP, M xor PeekCardinal(iPSP)) ;
end ; { code_exo }

procedure TfrmM3205.code_f_vergl;

{
     F-VERGL     Field Comparison
     <a> <b> <n> F-VERGL
     <result>

     This instruction compares n pairs of bytes starting at locations a and b.
     If equal, result is 1. If bytes in a are numerically greater than in b,
     result is 2, else 0. Higher addressed bytes are treated as more
     significant.

     Designed for atomic time/date comparisons
}

var

     iMemAddrA : Cardinal ;
     iMemAddrB : Cardinal ;
     iResult   : Cardinal ;
     iB1       : Byte ;
     iB2       : Byte ;
     iCount    : Cardinal ;

begin
  iCount    := PopCardinal ; { Number of Bytes }
  iMemAddrB := PopCardinal ;
  iMemAddrA := PeekCardinal(iPSP) ;
  iResult := 1 ;
  repeat
    iB1 := PeekByte(iMemAddrA) ;
    Inc(iMemAddrA) ;
    iB2 := PeekByte(iMemAddrB) ;
    Inc(iMemAddrB) ;
    if (iB1>iB2) then iResult := 2 ;
    if (iB1<iB2) then iResult := 0 ;
    iCount := (iCount - 1) and $ff ;
  until (iCount = 0) ;
  PokeCardinal(iPSP,iResult) ;
end ; { code_f_vergl }

procedure TfrmM3205.code_field_trans;
{
     ----------------
     Field Primitives
     ----------------

     >>>     Field Transport
     <source-addr> <dest-addr> <n> >>>
     empty. Copies n bytes from source-addr to dest-addr.
     1<=n <= 2147483647. Lowest address is copied first.
     First 64 bytes are moved atomic of the pseudo interrupt
}

var
  iSourceAddr      : Cardinal ;
  iDestinationAddr : Cardinal ;
  iCount           : Integer  ;
  iThisTime        : Integer  ;
  iB               : Byte     ;

begin

  iCount           := PopInteger  ;
  iDestinationAddr := PopCardinal ;
  iSourceAddr      := PopCardinal ;

  if (iCount>0) then begin

    if (iCount>64) then begin
      iThisTime := 64 ;
    end
    else begin
      iThisTime := iCount ;
    end ;

    iCount := iCount - iThisTime ;

    repeat
      iB := PeekByte(iSourceAddr) ;
      Inc(iSourceAddr) ;
      PokeByte(iDestinationAddr,iB) ;
      Inc(iDestinationAddr) ;
      Dec(iThisTime) ;
    until (iThisTime = 0) ;

    if (iCount<>0) then begin
      PushCardinal(iSourceAddr) ;
      PushCardinal(iDestinationAddr) ;
      PushInteger(iCount) ;
      iPPC := iPPC - 4 ;
    end ;

  end ;

end ; { code_field_trans }

procedure TfrmM3205.code_file_in;
{
    Service source file READ
}

var
  RowCount : byte    ;
  ColCount : byte    ;
  sLine    : string[255]  ;
  InEOL    : boolean ;
  InChar   : char    ;
  ii       : Cardinal ;
begin

  if (bIsOpen) and (PeekCardinal(kREADYFLAG)=0) and (PeekCardinal(kLOADFLAG)=1) then begin

    if (Eof(pTextFile)) then begin
      PokeCardinal(kLOADFLAG,0) ;
      code_closefile ;
    end
    else begin

      for ii := kTV8 to kTVE do begin
        PokeByte(ii,32) ;
      end ;

      iLOADPOINTER := kTV8 ;
      RowCount := 8 ;
      while (not Eof(pTextFile)) and (0<RowCount) do begin
        FillChar(sLine[1],255,$20) ;
        SetLength(sLine,255) ;
        ColCount := 1 ;
        InEOL := false ;

        while (not Eof(pTextFile)) and (not InEOL) do begin
          Read(pTextFile,InChar) ;
          InEOL := InChar = #10 ; { LineFeed }
          if (not InEOL) and (ColCount<65) and (InChar<>#13) { Return } then begin
            if (InChar<#32) then begin
              InChar := #32 ;
            end ;
            sLine[ColCount] := InChar ;
            Inc(ColCount) ;
          end ;
        end ;
        SetLength(sLine,64) ;
        for ColCount := 1 to 64 do begin
          PokeByte(iLOADPOINTER,BYTE(sLine[ColCount])) ;
          Inc(iLOADPOINTER) ;
        end ;
        Dec(RowCount) ;
      end ;
      if (Eof(pTextFile)) then begin
        PokeCardinal(kLOADFLAG,0) ;
        code_closefile ;
      end ;
      PokeCardinal(kPE,Pred(iLOADPOINTER)) ;
    end ;
  end ;

end ; { code_file_in }

procedure TfrmM3205.code_get;

{
     @   Get 32-bit word
     <addr> @
     <contents of addr>
}

begin
  PokeCardinal(iPSP,PeekCardinal(PeekCardinal(iPSP))) ;
end ; { code_get }

procedure TfrmM3205.code_getB;

{
     @B  Get byte
     <addr> @B
     <byte at addr, MSB = 0>
}

begin
  PokeCardinal(iPSP,PeekCardinal(PeekCardinal(iPSP)) and $ff) ;
end ; { code_getb }

procedure TfrmM3205.code_getPS;
{
     $PSHOLEN    gets the parameter stack pointer and pushes it on the parameter stack.

     REFERENCE:  IPS High Level Programming of Small Systems, 2nd Edition, Karl Meinzer, 1978
                 Page 88 - 6.2 Directly available code routines
}
begin
  PushCardinal(iPSP) ;
end ; { code_getPS }

procedure TfrmM3205.code_geu;

{
    >=U     Unsigned Test
    <n> <m> >=U
    <TRUE IF n>=m, as unsigned 32 bit numbers>
}

var
  M : Cardinal ;
begin
  M := PopCardinal ;                { <- variable to ensure execution order! }
  if (PeekCardinal(iPSP)>=M) then begin
    PokeCardinal(iPSP,1) ;
  end
  else begin
    PokeCardinal(iPSP,0) ;
  end ;
end ; { code_geu }

procedure TfrmM3205.code_gz;

{
     >0      Tests for greater than zero.
     <n> >0
     <TRUE IF n>0>
}

begin
  if (PeekInteger(iPSP)>0) then begin
    PokeCardinal(iPSP,1) ;
  end
  else begin
    PokeCardinal(iPSP,0) ;
  end ;
end ; { code_gz }

procedure TfrmM3205.code_index;

{
     I       Copies top of return stack to parameter stack.
     I
     <top of return stack>
}

begin
  PushCardinal(PeekCardinal(iRSP)) ;
end ; { code_index }

procedure TfrmM3205.code_ipptrcheck;
begin
  if (PeekCardinal(kREADYFLAG) = 0) then begin
    if (PeekCardinal(kPE)<iINPUTPOINTER) or (PeekCardinal(kPE)<iLOADPOINTER) then begin
      PokeCardinal(kREADYFLAG,1) ;
    end ;
  end ;
end ; { code_ipptrcheck }

procedure TfrmM3205.code_jeex;

{
     $JEEX      The action going with the JE. The address of the corresponding
                LOOPEX address follows $JEEX in the program to enable it to
                bypass the loop in it is not to be executed at all.

     REFERENCE: IPS High Level Programming of Small Systems, 2nd Edition,
                Karl Meinzer, 1978
                Pages 18 to 19 - 3.1.2 Loops
                Page 89 - 6.3 Code routines managed by the compiler

                JE NUN  Iteration loop, with a test at end of loop, with unity
                        increments. The value of the loop index is available by
                        the use of the word I.
                        NB: This construct uses the return stack.

                 <a> <b> JE
                 <iterated actions>
                 NUN

                 Index starts set to a and incremented by 1 until the index is
                 equal or greater than b.

     REFERENCE:  IPS Language Reference Manual Draft E 15 Feb 1996

     Private Communication from James R. Miller, April 25, 2001
}

var
  I : Int64    ;    { Iteration Counter }
  L : Cardinal ;    { Loop Limit }

begin

  iPPC := PeekCardinal(iPPC) ;
  PushRSCardinal(PopCardinal) ;
  I := PopCardinal ;

  L := PeekCardinal(iRSP) ;
  if (I<=L) then begin
    PushRSCardinal(T2Cardinal(I).a) ;
    iPPC := PeekCardinal(iPPC) ;
  end
  else begin
    L := PopRSCardinal ;
    iPPC := iPPC + 4 ;
  end ;
end ; { code_jeex }

procedure TfrmM3205.code_jump;
{
     JUMP         like BRONZ, but the jump is always taken and nothing is
                  taken off the stack. (Unconditional jump).

     REFERENCE:   IPS High Level Programming of Small Systems, 2nd Edition,
                  Karl Meinzer, 1978
                  Pages 18 to 19 - 3.1.2 Loops
                  Page 89 - 6.3 Code routines managed by the compiler
}

begin
  iPPC := PeekCardinal(iPPC) ;
end ; { code_jump }

procedure TfrmM3205.code_keyb;
{
    Service Keyboard
}

var
  InChar   : word  ;
  Index    : Cardinal ;
begin

  while (frmM3205.KeyWaiting) do begin

// Flag that screen needs updating

    PokeCardinal(kDVFLAG,1) ;

{
    Remove Blob Cursor
}

    PokeByte(iINPUTPOINTER,PeekByte(iINPUTPOINTER) and $7F) ;

    InChar := frmM3205.ReadKey ;

{
    PC Control Keys
}

    if (Hi(InChar)=$ff) then begin

       InChar := Lo(InChar) ;

       case InChar of
       $01 : begin { Home }
         iINPUTPOINTER := kTV8 ;
       end ;
       $02 : begin { Up Arrow }
         Dec(iINPUTPOINTER,64) ;
       end ;
       $03 : begin { Left Arrow }
         Dec(iINPUTPOINTER) ;
       end ;
       $04 : begin { Right Arrow }
         Inc(iINPUTPOINTER) ;
       end ;
       $05 : begin { End }
         iINPUTPOINTER := kTVE ;
       end ;
       $06 : begin { Down Arrow }
         Inc(iINPUTPOINTER,64) ;
       end ;
       $07 : begin { Insert }
         bInsertON := not bInsertON ;
       end ;
       $08 : begin { Delete }
         for Index := iINPUTPOINTER to Pred(kTVE) do begin
           PokeByte(Index,PeekByte(Succ(Index))) ;
         end ;
         PokeByte(kTVE,32) ;
       end ;
       else
       end ;

       iINPUTPOINTER := iINPUTPOINTER and $3FF ;

     end

{
     Return! ... do stuff!
}

     else if (InChar = 13) then begin
       PokeCardinal(kPE, Pred(iINPUTPOINTER)) ;
     end
     else if (InChar = 8) then begin { BackSpace }
       iINPUTPOINTER := Pred(iINPUTPOINTER) and $3FF ;
       PokeByte(iINPUTPOINTER,32) ;
       if (bInsertON) then begin
          for Index := iINPUTPOINTER to kTVE do begin
            PokeByte(Index,PeekByte(Succ(Index))) ;
          end ;
          PokeByte(kTVE,32) ;
       end ;
     end

     else begin
       if (bInsertON) and (kTV8<=iINPUTPOINTER) then begin
         for Index := kTVE downto Succ(iINPUTPOINTER) do begin
           PokeByte(Index,PeekByte(Pred(Index))) ;
         end ;
       end ;
       PokeByte(iINPUTPOINTER, Lo(InChar)) ;
       iINPUTPOINTER := Succ(iINPUTPOINTER) and $3FF ;
     end ;

{
    Put Blob Cursor On Screen iff not end of input
}

     if (iINPUTPOINTER<=PeekCardinal(kPE)) then begin
       PokeByte(iINPUTPOINTER,PeekByte(iINPUTPOINTER) or $80) ;
     end ;

   end ;

end ; { code_keyb }

procedure TfrmM3205.code_loadcode;
{
     $LOADCODE - is called by LOAD, which loads a file to memory.
     Requires 3 items on the stack; address to load data, and filename
     pointers. Removes three items from stack, and returns one item
     on the stack value 1 for success, 0 for failure of some kind plus
     debris.

     REFERENCE: James R. Miller, Private Communication, December 18, 2000.

     NOTE: The filename pointers are Start Address, and Length.

     i.e.

     The keyboard commands: <Load Address> " FILENAME " $LOAD

     generates:

     <Load Address> <Filename Start Address> <Filename Length> $LOADCODE
}

var
  LoadAddr  : Cardinal         ;
  ByteValue : Byte         ;
  FSize     : Int64      ;
  TextFile  : file of byte ;

label
  Failure, Failure2 ;

begin

  AssignFile(TextFile,PopStr) ;
  LoadAddr  := PopCardinal ;

  {$i-}
  Reset(TextFile) ;
  if (IOResult<>0) then begin
    goto Failure ;
  end ;
  FSize := FileSize(TextFile) ;
  if (IOResult<>0) then begin
    goto Failure2 ;
  end ;
  if (FSize=0) or ((LoadAddr+FSize)>kHighestAddress) then begin
    goto Failure2 ;
  end ;
  {$i+}

  while (not Eof(TextFile)) do begin
    Read(TextFile,ByteValue) ;
    PokeByte(LoadAddr,ByteValue) ;
    Inc(LoadAddr) ;
  end ;

  CloseFile(TextFile) ;

  PushCardinal(1) ;

  Exit ;

Failure2:

  CloseFile(TextFile) ;

Failure:

  {$i+}
  PushCardinal(LoadAddr) ;
  PushCardinal(0) ;

end ; { code_loadcode }

procedure TfrmM3205.code_loopex;

{
     LOOPEX     the action taken with the NUN of loops. The address to the
                loop entry follows LOOPEX in the program. The NUN increments
                the iteration counter and the checks whether it exceeds the
                loop limit. IF not, the loop (between JE and NUN) repeats.
                Else, the NUN discards the two parameters on the return stack
                and the loop is terminated. Inside the loop the loop limit and
                the iteration counter are on the return stack; the later on
                top. IF the initial value of the iteration counter exceeds
                the limit, the loop action is not executed at all.

     REFERENCE: IPS High Level Programming of Small Systems, 2nd Edition,
                Karl Meinzer, 1978
                Pages 18 to 19 - 3.1.2 Loops
                Page 89 - 6.3 Code routines managed by the compiler

                JE NUN  Iteration loop, with a test at end of loop, with unity
                        increments. The value of the loop index is available by
                        the use of the word I.
                        NB: This construct uses the return stack.

                 <a> <b> JE
                 <iterated actions>
                 NUN

                 Index starts set to a and incremented by 1 until the index is
                 equal or greater than b.

     REFERENCE:  IPS Language Reference Manual Draft E 15 Feb 1996

     Private Communication from James R. Miller, April 25, 2001

     16-BIT EXAMPLE:

     : LOOP JE I @ 2 +NUN ; compiles as (e.g.):

     ADDRESS DATA
     ---------------------------------------
     #1DA1 #5C04 ]
     #1DA3 #2389 5C 89 23 hash_name LOOP ] Header stuff
     #1DA5 #1D55 #1D55 (prev defn. start) ]

     #1DA7 #0F0D DEFEX ( entry)
     #1DA9 #0C47 $JEEX
     #1DAB #1DB5 ----------+
     #1DAD +-->#0CF6 I |
     #1DAF | #0B7C @ |
     #1DB1 | #0FEE 2 kon |
     #1DB3 | #0C2E +LOOPEX |
     #1DB5 +-- #1DAD <---------+
     #1DB7 #0BD0 RETEX

}

var
  I   : Int64 ;    { Iteration Counter }
  L   : Cardinal ; { Loop Limit }

begin
  I := PopRSCardinal ;
  I := I + 1 ;
  L := PeekCardinal(iRSP) ;
  if (I<=L) then begin
    PushRSCardinal(T2Cardinal(I).a) ;
    iPPC := PeekCardinal(iPPC) ;
  end
  else begin
    L := PopRSCardinal ;
    iPPC := iPPC + 4 ;
  end ;
end ; { code_loopex }

procedure TfrmM3205.code_lz;

{
     <0      Tests for less than zero.
     <n> <0
     <TRUE IF n<0>
}

begin
  if (PeekInteger(iPSP)<0) then begin
    PokeCardinal(iPSP,1) ;
  end
  else begin
    PokeCardinal(iPSP,0) ;
  end ;
end ; { code_lz }

procedure TfrmM3205.code_minus;

{
     -   Subtracts 2 2s complement 32-Bit Integers
     <n> <m> -
     <n-m>
}

var
  M : integer ;
begin
  M := PopInteger ;  { <- variable used to guarentee execution order! }
  PushInteger(PopInteger-M) ;
end ; { code_minus }

procedure TfrmM3205.code_nicht;

{
    NICHT   Inverts all bits
     <bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb> NICHT
     <b*b*b*b*b*b*b*b*b*b*b*b*b*b*b*b*b*b*b*b*b*b*b*b*b*b*b*b*b*b*b*b*>
     (b* = complement of b)
}

begin
  PokeCardinal(iPSP, not PeekCardinal(iPSP)) ;
end ; { code_nicht }

procedure TfrmM3205.code_oder;

{
     ODER    Logically ORs all bits
     <n> <m> ODER
     <n OR m, bitwise>
}

var
     M : Cardinal ;
begin
  M := PopCardinal ;
  PokeCardinal(iPSP, M or PeekCardinal(iPSP)) ;
end ; { code_oder }

procedure TfrmM3205.code_openfile;
{
     $OPENFILE - is called by READ, which executes a file of IPS
     words. Expects two items on the stack which are pointers to
     the start and end of the filename you typed in on the screen as
     in " MYFILE " READ. Removes two items from the stack, and returns
     one item on the stack, value 1 for success, 0 for failure of
     some kind plus debris.

     REFERENCE: James R. Miller, Private Communication, December 18, 2000.

     NOTE: The filename pointers are Start Address, and Length.

     i.e.

     The keyboard commands: " FILENAME " READ

     generates:

     <Filename Start Address> <Filename Length> $OPENFILE
}

label
  Failure ;

begin

  AssignFile(pTextFile,PopStr) ;
  {$i-}
  Reset(pTextFile) ;
  if (IOResult<>0) then begin
    goto Failure ;
  end ;
  {$i+}

  PushCardinal(1) ;

  bIsOpen := true ;

  Exit ;

Failure:

  {$i+}
  PushCardinal(0) ;

end ; { code_openfile }

procedure TfrmM3205.code_pdiv;

{
     P/MOD   Divides a 64 bit positive word by a 32 bit positive word,
             produces 32 bit quotient and 32 bit remainder.
             IF the quotient overflows it is set to #FFFFFFFF.
     <n, least sig. 32 bits> <n, most sig. 32 bits> <m> P/MOD
     <quotient n/m> <remainder n/m>

     REFERENCE: IPS Language Reference Manual Draft E 15 Feb 1996
}

const

  BigScale : Int64 = $100000000 ;

var

  N : Int64 ;
  M : Int64 ;
  Q : Int64 ;
  R : Int64 ;

{
     64-bit Divide N / M returning 64-bit Quotient (Q) and Remainder (R)
}

procedure Div64(N:Int64;M:Int64;var Q:Int64;var R:Int64) ;
var
  i : Cardinal ;
begin
  Q := N ;
  R := 0 ;
  for i := 1 to 64 do begin
    Add64(R shl 1,Q shr 63,R) ;
    Q := Q shl 1 ;
    if (Compare64(R,M)<>-1) then begin
      Subtract64(M,R,R) ; { R = R - M }
      Add64(Q,1,Q) ;
    end ;
  end ;
end ; { Div64 }

begin

  M := PopCardinal ;
  N := PopCardinal * BigScale ;
  N := N + PopCardinal ;

  if (M=0) then begin
    Q := $ffffffff ;
    R := $00000000 ;
  end
  else begin
    Div64(N,M,Q,R) ;
    if (Compare64($ffffffff,Q)=-1) then begin
      Q := $ffffffff ;
      R := $00000000 ;
    end ;
  end ;

  PushCardinal(Q and $ffffffff) ;
  PushCardinal(R and $ffffffff) ;

end ; { code_pdiv }

procedure TfrmM3205.code_pdup;

{
     PDUP    Duplicates 2 stack entries.
     <n> <m> PDUP
     <n> <m> <n> <m>
}

begin
  PushCardinal(PeekCardinal(iPSP+4)) ;
  PushCardinal(PeekCardinal(iPSP+4)) ;
end ; { code_pdup }

procedure TfrmM3205.code_plus;

{
     +   Adds 2 2s complement 32-bit numbers
     <n> <m> +
     <n+m>
}

begin
  PushInteger(PopInteger+PopInteger) ;
end ; { code_plus }

procedure TfrmM3205.code_plusloopex;


{
     +LOOPEX    like LOOPEX, but now the +NUN taking the increment off the
                stack.

     REFERENCE: IPS High Level Programming of Small Systems, 2nd Edition,
                Karl Meinzer, 1978
                Pages 18 to 19 - 3.1.2 Loops
                Page 89 - 6.3 Code routines managed by the compiler

                 JE +NUN Iteration loop, with a test at end of loop, and
                         non unity increments. The value of the loop index is
                         available by the use of the word I. NB: This construct
                         uses the return stack.

                 <a> <b> JE
                 <iterated actions>
                 <n> +NUN

                 Index starts set to a and takes an increment n off the stack
                 each time through the loop until the index is equal to or
                 greater than b.

     REFERENCE:  IPS Language Reference Manual Draft E 15 Feb 1996

     Private Communication from James R. Miller, April 25, 2001
}

var
  I : Int64    ;    { Iteration Counter }
  L : Cardinal ;    { Loop Limit }

begin
  I := PopRSCardinal ;
  I := I + PopCardinal ;
  L := PeekCardinal(iRSP) ;
  if (I<=L) then begin
    PushRSCardinal(T2Cardinal(I).a) ;
    iPPC := PeekCardinal(iPPC) ;
  end
  else begin
    L := PopRSCardinal ;
    iPPC := iPPC + 4 ;
  end ;
end ; { code_plusloopex }

procedure TfrmM3205.code_pminus;

{
     P-  Subtracts 2 32-bit 2s complement words.
     <n-LSB> <n-MSB> <m-LSB> <m-MSB> P-
     <n-m LSB> <n-m MSB>

     REFERENCE: One liner from James!
}


var
  N, M, R : Int64 ;

{
     Subtract64 - Subtracts 2 unsigned 64 bit d-words (N & M) to
     form Unsigned 64 bit result (R=M-N).
}


begin { code_pminus }

  T2Cardinal(M).b := PopCardinal ;
  T2Cardinal(M).a := PopCardinal ;
  T2Cardinal(N).b := PopCardinal ;
  T2Cardinal(N).a := PopCardinal ;

  Subtract64(M,N,R) ;

  PushCardinal(T2Cardinal(R).a) ;
  PushCardinal(T2Cardinal(R).b) ;

end ; { code_pminus }

procedure TfrmM3205.code_pmul;

{
     P*      Multiplies 2 32 bit positive words, result is their 64 bit product
     <n> <m> P*
     <n * m, least sig. 32 bits>, <n * m, most sig. 32 bits>

     REFERENCE: IPS Language Reference Manual Draft E 15 Feb 1996
}

var
  R : Int64 ;

{
     Unsigned Multiply of 32 bit words N & M to form 64-bit unsigned result R
}

procedure Mult32(N,M:Cardinal;var R:Int64) ;

var
  _N : packed array[0..3] of byte absolute N ;
  _M : packed array[0..3] of byte absolute M ;
  _R : packed array[0..7] of byte absolute R ;
  A  : byte ;
  B  : byte ;
  C  : word ;
  D  : Int64 ;
  _D : packed array[0..7] of byte absolute D ;
begin
  R := 0 ;
  for A := 0 to 3 do begin
    for B := 0 to 3 do begin
      D := 0 ;
      C := 0 ;
      C := $ffff and (_N[A] * _M[B]) ;
      _D[A+B] := C and $ff ;
      _D[A+B+1] := C shr 8 ;
      Add64(R,D,R) ;
    end ;
  end ;

end { Mult32 } ;

begin { code_pmul }
  Mult32(PopCardinal,PopCardinal,R) ; // <- 32bit x 32bit Multiply 64bit Result
  PushCardinal(T2Cardinal(R).a) ;
  PushCardinal(T2Cardinal(R).b) ;
end ; { code_pmul }

procedure TfrmM3205.code_pplus;
{
     P+  Adds 2 64-bit 2s complement words.
     <n-LSC> <n-MSC> <m-LSC> <m-MSC> P+
     <n+m LSC> <n+m MSC>

     REFERENCE: One liner from James!
}

var
  N, M, R : Int64 ;

begin
  T2Cardinal(M).b := PopCardinal ;
  T2Cardinal(M).a := PopCardinal ;
  T2Cardinal(N).b := PopCardinal ;
  T2Cardinal(N).a := PopCardinal ;

  Add64(M,N,R) ;

  PushCardinal(T2Cardinal(R).a) ;
  PushCardinal(T2Cardinal(R).b) ;

end ; { code_pplus }

procedure TfrmM3205.code_put;
{
     !   Store 32 bit word
     <n> <addr> !
     empty. Word at addr now contains value n.
}

var
  iMemAddr : Cardinal ;
begin
  iMemAddr := PopCardinal ;
  PokeCardinal(iMemAddr, PopCardinal) ;
end ; { code_put }

procedure TfrmM3205.code_putB;
{
     !B  Store byte
     <n> <addr> !B
     empty. Byte at addr now contains LSB of n.
     Only 1 byte is affected.
}

var
  iMemAddr : Cardinal ;
begin
  iMemAddr := PopCardinal ;
  PokeByte(iMemAddr,Lo(PopCardinal)) ;
end ; { putb }

procedure TfrmM3205.code_pweg;

{
     PWEG    Destroy 2 entries
     <m> <n> PWEG
     empty
}

begin
  Inc(iPSP,8) ;
end ; { code_pweg }

procedure TfrmM3205.code_r_to_s;

{
     R>S     Moves one word from return stack to parameter stack.
     R>S <top of return stack>. Top is lost from return stack.
}

begin
  PushCardinal(PopRSCardinal) ;
end ; { code_r_to_s }

procedure TfrmM3205.code_rdo;
{
     RDO     Rotates 3 entries.
     <a> <b> <c> RDO
     <b> <c> <a>
}

var
  A : Cardinal ;
  B : Cardinal ;
  C : Cardinal ;

begin
  C := PopCardinal ;
  B := PopCardinal ;
  A := PopCardinal ;
  PushCardinal(B) ;
  PushCardinal(C) ;
  PushCardinal(A) ;
end ; { code_rdo }

procedure TfrmM3205.code_rdu;

{
     RDU     Rotates 3 entries.
     <a> <b> <c> RDU
     <c> <a> <b>
}

var
  A : Cardinal ;
  B : Cardinal ;
  C : Cardinal ;

begin
     C := PopCardinal ;
     B := PopCardinal ;
     A := PopCardinal ;
     PushCardinal(C) ;
     PushCardinal(A) ;
     PushCardinal(B) ;
end ; { code_rdu }

procedure TfrmM3205.code_retex;

{
     RETEX        exits from a definition. It is compiled by the ; and
                  using this word directly allows multiple exits from a
                  definition.

     REFERENCE:   IPS High Level Programming of Small Systems, 2nd Edition,
                  Karl Meinzer, 1978
                  Page 15 - 3.1 Definitions
                  Page 88 - 6.2 Directly available code routines
}

begin
  iPPC := PopRSCardinal ;
end ; { code_retex }

procedure TfrmM3205.code_rumpelstilzchen;
{
     Dummy Procedure, ... No-Op!
}
begin
//
end ; { code_rumpelstilzchen }

procedure TfrmM3205.code_s_to_r;

{
     S>R     Moves parameter stack to return stack.
     <n> S>R
     empty. <n> is now top of the return stack.
}

begin
  PushRSCardinal(PopCardinal) ;
end ; { code_s_to_r }

procedure TfrmM3205.code_savecode;
{
     $SAVECODE - is called by SAVE ; saves out a block of memory.
     Requires 4 items on the stack; Start addr, last addr+1 and filename
     pointers. Removes 4 items from stack, and returns one item on the
     stack, value 1 for success, 0 for failure of some kind, plus debris.

     REFERENCE: James R. Miller, Private Communication, December 18, 2000.
}

var
  LastAddr  : Cardinal    ;
  StartAddr : Cardinal    ;
  BlockLen  : Int64 ;
  ByteValue : byte    ;
  TextFile  : file of byte  ;

label
  Failure ;

begin

  AssignFile(TextFile,PopStr) ;
  LastAddr := PopCardinal ;
  StartAddr := PopCardinal ;
  BlockLen := LastAddr - StartAddr ;

  if (BlockLen<>0) and (StartAddr<LastAddr) then begin

    {$i-}
    ReWrite(TextFile) ;
    if (IOResult<>0) then begin
      goto Failure ;
    end ;
    {$i+}

    BlockLen := ((BlockLen+511) div 512) * 512 ;

    while (0<BlockLen) do begin
      ByteValue := PeekByte(StartAddr) ;
      Write(TextFile,ByteValue) ;
      Inc(StartAddr) ;
      Dec(BlockLen) ;
    end ;

    CloseFile(TextFile) ;

    PushCardinal(1) ;

    Exit ;

  end ;

Failure:

  {$i+}
  PushCardinal(StartAddr) ;
  PushCardinal(LastAddr) ;
  PushCardinal(0) ;

end ; { code_savecode }

procedure TfrmM3205.code_sbit;

{
     SBIT    Set bit of byte.
     <bit-no> <addr of byte> SBIT
     Bit specIFied set to 1, all other bits unaffected.
}

var
  iMemAddr : Cardinal ;

begin
  iMemAddr := PopCardinal ;
  PokeByte(iMemAddr, PeekByte(iMemAddr) or T4Byte((1 shl PopCardinal)).a) ;
end ; { code_sbit }

procedure TfrmM3205.code_setkbptr;
{
     This is the code for the IPS word $IPSETZEN Takes a value off the stack,
     sets the keyboard pointer to this, AND &3FF. This will be where the cursor
     appears (a black blob) and where new typing will thus appear.
}

begin
  iINPUTPOINTER := PopCardinal and $3FF ;
  iLOADPOINTER := iINPUTPOINTER ;
  PokeByte(iINPUTPOINTER,PeekByte(iINPUTPOINTER) or $80) ;
end ; { code_setkbptr }

procedure TfrmM3205.code_setPS;
{
     $PSSETZEN   takes a number off the parameter stack and sets the stack pointer to this
                 number.

     REFERENCE:  IPS High Level Programming of Small Systems, 2nd Edition, Karl Meinzer, 1978
                 Page 88 - 6.2 Directly available code routines
}
begin
  iPSP := PopCardinal ;
end ; { code_setPS }

procedure TfrmM3205.code_StopWatch(StopWatchAddress: Cardinal);

var
  MilliSeconds : byte ;
  Seconds      : byte ;
  Minutes      : word ;
begin

  MilliSeconds := PeekByte(StopWatchAddress) ;

  if ((MilliSeconds and $01) <> 1) then begin
    if (0 < MilliSeconds) then begin
      MilliSeconds := MilliSeconds - 2 ;
    end
    else begin
      MilliSeconds := 98 ;
      Seconds := PeekByte(StopWatchAddress + 1) ;
      if (0 < Seconds) then begin
        Seconds := Seconds - 1 ;
      end
      else begin
        Seconds := 59 ;
        Minutes := PeekWord(StopWatchAddress + 2) ;
        if (0 < Minutes) then begin
          Minutes := Minutes - 1 ;
          PokeWord(StopWatchAddress + 2, Minutes) ;
        end
        else begin
          Seconds := 0 ;
          MilliSeconds := 1 ;
        end ;
      end ;
      PokeByte(StopWatchAddress + 1, Seconds) ;
    end ;
    PokeByte(StopWatchAddress, MilliSeconds) ;
  end ;

end ; { code_StopWatch }

procedure TfrmM3205.code_tbit;

{
     TBIT    Test bit of byte
     <bit-no> <addr of byte> TBIT
     <result>
     Result is 1 if bit specified is 1, 0 if bit specified is 0.
}

var
  iMemAddr : Cardinal ;

begin
  iMemAddr := PopCardinal ;
  if ( PeekByte(iMemAddr) and T4Byte(1 shl PopCardinal).a = 0 ) then begin
     iMemAddr := 0 ;
  end
  else begin
     iMemAddr := 1 ;
  end ;
  PushCardinal(iMemAddr) ;
end ;{ code_tbit }
(*
procedure TfrmM3205.code_tue;
{
     $TUE       expects a typecode field address on the stack. $TUE executes
                this word and thus allows indirect execution.

     REFERENCE: IPS High Level Programming of Small Systems, 2nd Edition,
                Karl Meinzer, 1978
                Page 88 - 6.2 Directly available code routines
}

begin
  iHP := PopCardinal ;
  iCPC := PeekCardinal(iHP) ;
  iHP := iHP + 4 ;
  pJumpTable[T4Byte(iCPC).a] ;
end ; { code_tue }
*)
procedure TfrmM3205.code_uhr;
var
  MilliSeconds : byte ;
  Seconds      : byte ;
  Minutes      : byte ;
  Hours        : byte ;
  dNow         : TDateTime ;

begin

// Force Clock

  if (ForceClock) then begin

    dNow := Now - UTCOffset/24.0 ;

    PokeByte(kUHR+0,(MilliSecondOf(dNow) div 10) and $fe) ;
    PokeByte(kUHR+1, SecondOf(dNow) ) ;
    PokeByte(kUHR+2, MinuteOf(dNow) ) ;
    PokeByte(kUHR+3,   HourOf(dNow) ) ;

    PokeWord(kUHR+4, Trunc(DateTimeToModifiedJulianDate(DateOf(dNow))) -
                     Trunc(DateTimeToModifiedJulianDate(EnCodeDate(1978,1,1)))
             ) ;
  end
  else begin
    MilliSeconds := PeekByte(kUHR) ;
    if (MilliSeconds < 98) then begin
      MilliSeconds := MilliSeconds + 2 ;
    end
    else begin
      MilliSeconds := 0 ;
      Seconds      := PeekByte(kUHR+1) ;
      if (Seconds<59) then begin
        Inc(Seconds) ;
      end
      else begin
        Seconds := 0 ;
        Minutes      := PeekByte(kUHR+2) ;
        if (Minutes<59) then begin
          Inc(Minutes) ;
        end
        else begin
          Minutes := 0 ;
          Hours        := PeekByte(kUHR+3) ;
          if (Hours<23) then begin
            Inc(Hours) ;
          end
          else begin
            Hours := 0 ;
            PokeWord(kUHR+4,Succ(PeekWord(kUHR+5))) ; { Days }
          end ;
          PokeByte(kUHR+3,Hours) ;
        end ;
        PokeByte(kUHR+2,Minutes) ;
      end ;
      PokeByte(kUHR+1,Seconds) ;
    end ;
    PokeByte(kUHR,MilliSeconds) ;
  end ;

{
     Update Stop Watches
}

  code_StopWatch(kSU0) ;
  code_StopWatch(kSU1) ;
  code_StopWatch(kSU2) ;
  code_StopWatch(kSU3) ;

end ; { code_uhr }

procedure TfrmM3205.code_und;

{
     UND     Logically ANDs all bits.
     <n> <m> UND
     <n AND m, bitwise>
}

var
  M : Cardinal ;

begin
  M := PopCardinal ;
  PokeCardinal(iPSP,M and PeekCardinal(iPSP)) ;
end ; { code_und }

procedure TfrmM3205.code_varex;
begin
  PushCardinal(iHP) ;
end ; { code_varex }

procedure TfrmM3205.code_vert;

{
     VERT    Swap top 2 entries
     <n> <m> VERT
     <m> <n>
}

var
  M : Cardinal ;
  N : Cardinal ;

begin
  M := PopCardinal ;
  N := PopCardinal ;
  PushCardinal(M) ;
  PushCardinal(N) ;
end ; { code_vert }

procedure TfrmM3205.code_weg;

{
     WEG     Destroy top entry
     <m> <n> WEG
     <m>
}

begin
  Inc(iPSP,4) ;
end ; { code_weg }

procedure TfrmM3205.code_zwo;

{
     ZWO     Duplicate 2nd entry
     <n> <m> ZWO
     <n> <m> <n>
}

begin
  PushCardinal(PeekCardinal(iPSP+4)) ;
end ; { code_zwo }

procedure TfrmM3205.DumpMemory;
var
  LogFile : TextFile ;
  iAddr : Cardinal ;
  kk : byte ;
begin
  AssignFile(LogFile,'c:\error.d') ;
  ReWrite(LogFile) ;

  for iAddr := $00000000 to $1FFFF do begin
    kk :=PeekByte(iAddr) ;
    if (iAddr mod 16 = 0) then begin
      WriteLn(LogFile) ;
      Write(LogFile,'#' + HexStrCardinal(iAddr)+': ' ) ;
    end ;
    Write(LogFile,'#'+HexStrByte(PeekByte(iAddr))+' ') ;
  end ;
  WriteLn(LogFile) ;
  CloseFile(LogFile) ;

end ; { DumpMemory }

function TfrmM3205.PeekByte(iAddress: Cardinal): byte;
begin
  if (iAddress<=kHighestAddress) then begin
    result := iMemorySpace[iAddress] ;
  end
  else begin
    DumpMemory ;
    raise Exception.Create('Peek Byte - Bad Address: ' + HexStrCardinal(iAddress)) ;
  end ;
end { PeekByte } ;

function TfrmM3205.PeekCardinal(iAddress: Cardinal): Cardinal;
var
  ii : Cardinal ;
begin
  T4Byte(ii).a := PeekByte(iAddress+0) ;
  T4Byte(ii).b := PeekByte(iAddress+1) ;
  T4Byte(ii).c := PeekByte(iAddress+2) ;
  T4Byte(ii).d := PeekByte(iAddress+3) ;
  result := ii ;
end ; { PeekCardinal }

function TfrmM3205.PeekInteger(iAddress: Cardinal): integer;
begin
  result := integer(PeekCardinal(iAddress)) ;
end ; { PeekInteger }

function TfrmM3205.PeekWord(iAddress: Cardinal): word;
begin
  T2Byte(result).a := PeekByte(iAddress+0) ;
  T2Byte(result).b := PeekByte(iAddress+1) ;
end ; { PeekWord }

procedure TfrmM3205.PokeByte(iAddress: Cardinal; iValue: byte);
begin

// Check that Address is safe

  if (iAddress<=kHighestAddress) then begin
// Put byte into Memory Space
    iMemorySpace[iAddress] := iValue ;
    if (kTV0<=iAddress) and (iAddress<=kTVE) then begin
      DrawChar(iAddress) ;
    end ;
  end
  else begin
    DumpMemory ;
    raise Exception.Create('PokeByte - Bad Address: ' + HexStrCardinal(iAddress)) ;
  end ;

end { PokeByte } ;

procedure TfrmM3205.PokeCardinal(iAddress, iValue: Cardinal);
begin
  PokeByte(iAddress+0,T4Byte(iValue).a) ;
  PokeByte(iAddress+1,T4Byte(iValue).b) ;
  PokeByte(iAddress+2,T4Byte(iValue).c) ;
  PokeByte(iAddress+3,T4Byte(iValue).d) ;
end ; { PokeCardinal }

procedure TfrmM3205.PokeInteger(iAddress: Cardinal; iValue: integer);
begin
  PokeCardinal(iAddress,cardinal(iValue)) ;
end ; { PokeInteger }

procedure TfrmM3205.PokeWord(iAddress: Cardinal; iValue: word);
begin
  PokeByte(iAddress+0,T2Byte(iValue).a) ;
  PokeByte(iAddress+1,T2Byte(iValue).b) ;
end ; { PokeWord }

function TfrmM3205.PopCardinal: Cardinal;
begin
  result := PeekCardinal(iPSP) ;
  Inc(iPSP,4) ;
end ; { PopCardinal }

function TfrmM3205.PopInteger: integer;
begin
  result := integer(PopCardinal) ;
end ; { PopInteger }

function TfrmM3205.PopRSCardinal: Cardinal;
begin
  result := PeekCardinal(iRSP) ;
  Inc(iRSP,4) ;
end ; { PopRSCardinal }
(*
function TfrmM3205.PopRSInteger: integer;
begin
  result := integer(PopRSCardinal) ;
end ; { PopRSInteger }
*)
function TfrmM3205.PopStr: string;
{
     This routine returns the string specified in IPS " STR " on
     the stack.
}

var
  StrLen   : Cardinal   ;
  StrStart : Cardinal   ;
  OutStr   : string ;
begin

  StrLen := PopCardinal ;
  StrStart := PopCardinal ;

  OutStr := '' ;
  while (0<StrLen) do begin
    OutStr := OutStr + CHAR(PeekByte(StrStart)) ;
    Inc(StrStart) ;
    Dec(StrLen) ;
  end ;

  result := OutStr ;

end ; { PopStr }

procedure TfrmM3205.PushCardinal(iValue: Cardinal);
begin
  Dec(iPSP,4) ;
  PokeCardinal(iPSP,iValue) ;
end ; { PushCardinal }

procedure TfrmM3205.PushInteger(iValue: integer);
begin
  PushCardinal(cardinal(iValue)) ;
end ; { PushInteger }

procedure TfrmM3205.PushRSCardinal(iValue: Cardinal);
begin
  Dec(iRSP,4) ;
  PokeCardinal(iRSP,iValue) ;
  if (iRSP<$500) then begin
    raise Exception.Create('Return Stack Overflow ') ;
  end ;
end ; { PushRSCardinal }
(*
procedure TfrmM3205.PushRSInteger(iValue: integer);
begin
  PushRSCardinal(cardinal(iValue)) ;
end ; { PushRSInteger }
*)
procedure TfrmM3205.Execute;

var
  BinaryImage : file of byte ;
  MemValue    : byte         ;
  Index       : Cardinal     ;
  pRect       : TRect        ;
  iReqMemSize : Cardinal     ;
begin

// Set Running Flag

  bIsRunning := true ;

// Setup Screen

  pRect.TopLeft.X := 0 ;
  pRect.TopLeft.Y := 0 ;
  pRect.BottomRight.X := imgTVScreen.Width ;
  pRect.BottomRight.Y := imgTVScreen.Height ;

  with imgTVScreen.Canvas do begin
    Font.Name := 'Courier New' ;
    Font.Size := 11 ;
    Brush.Color := kBackColour ;
    FillRect(pRect);
  end ;

//  Load IPS32-M kernel

  SetLength(iMemorySpace,kHighestAddress+1) ;

  AssignFile(BinaryImage, KernelFilename) ;
  Reset(BinaryImage) ;
  Index := $00000000 ;
  while (not Eof(BinaryImage)) do begin

    Read(BinaryImage,MemValue) ;
    PokeByte(Index,MemValue) ;

    if (Index=$00000500) then begin
      iReqMemSize := PeekCardinal(kSIZE) ;
      if (iReqMemSize>kHighestAddress+1) then begin
        SetLength(iMemorySpace,iReqMemSize) ;
        kHighestAddress := iReqMemSize-1 ;
      end
      else begin
        PokeCardinal(kSIZE,kHighestAddress+1) ;
      end ;
    end ;

    Inc(Index) ;

  end ;
  CloseFile(BinaryImage) ;

//  Init Stack Pointers

  iRSP := kRETURNSTACK ;
  iPSP := (kHighestAddress+1) - $10 ;

// Set JumpTable to Dummy IPS Primative (NO-OP)

  for Index := $00 to $ff do begin
    pJumpTable[Index] := code_rumpelstilzchen ;
  end ;

// Set JumpTable for IPS Primatives

  pJumpTable[ips_return]      := code_rumpelstilzchen ;
  pJumpTable[ips_defex]       := code_defex           ;
  pJumpTable[ips_consex]      := code_consex          ;
  pJumpTable[ips_varex]       := code_varex           ;
  pJumpTable[ips_retex]       := code_retex           ;
  pJumpTable[ips_get]         := code_get             ;
  pJumpTable[ips_getB]        := code_getb            ;
  pJumpTable[ips_put]         := code_put             ;
  pJumpTable[ips_putB]        := code_putb            ;
  pJumpTable[ips_blit_4]      := code_blit_4          ;
  pJumpTable[ips_bronz]       := code_bronz           ;
  pJumpTable[ips_jump]        := code_jump            ;
  pJumpTable[ips_weg]         := code_weg             ;
  pJumpTable[ips_pweg]        := code_pweg            ;
  pJumpTable[ips_plus]        := code_plus            ;
  pJumpTable[ips_minus]       := code_minus           ;
  pJumpTable[ips_pplus]       := code_pplus           ;
  pJumpTable[ips_pminus]      := code_pminus          ;
  pJumpTable[ips_dup]         := code_dup             ;
  pJumpTable[ips_pdup]        := code_pdup            ;
  pJumpTable[ips_vert]        := code_vert            ;
  pJumpTable[ips_zwo]         := code_zwo             ;
  pJumpTable[ips_rdu]         := code_rdu             ;
  pJumpTable[ips_rdo]         := code_rdo             ;
  pJumpTable[ips_index]       := code_Index           ;
  pJumpTable[ips_s_to_r]      := code_s_to_r          ;
  pJumpTable[ips_r_to_s]      := code_r_to_s          ;
  pJumpTable[ips_eqz]         := code_eqz             ;
  pJumpTable[ips_gz]          := code_gz              ;
  pJumpTable[ips_lz]          := code_lz              ;
  pJumpTable[ips_geu]         := code_geu             ;
  pJumpTable[ips_f_vergl]     := code_f_vergl         ;
  pJumpTable[ips_nicht]       := code_nicht           ;
  pJumpTable[ips_und]         := code_und             ;
  pJumpTable[ips_oder]        := code_oder            ;
  pJumpTable[ips_exo]         := code_exo             ;
  pJumpTable[ips_bit]         := code_bit             ;
  pJumpTable[ips_cbit]        := code_cbit            ;
  pJumpTable[ips_sbit]        := code_sbit            ;
  pJumpTable[ips_tbit]        := code_tbit            ;
  pJumpTable[ips_jeex]        := code_jeex            ;
  pJumpTable[ips_loopex]      := code_loopex          ;
  pJumpTable[ips_plusloopex]  := code_plusloopex      ;
  pJumpTable[ips_field_trans] := code_field_trans     ;
  pJumpTable[ips_pmul]        := code_pmul            ;
  pJumpTable[ips_pdiv]        := code_pdiv            ;
  pJumpTable[ips__polyname]   := code__polyname       ;
  pJumpTable[ips_chs]         := code_chs             ;
  pJumpTable[ips_cyc2]        := code_cyc2            ;
  pJumpTable[ips_closefile]   := code_closefile       ;
  pJumpTable[ips_openfile]    := code_openfile        ;
  pJumpTable[ips_loadcode]    := code_loadcode        ;
  pJumpTable[ips_savecode]    := code_savecode        ;
  pJumpTable[ips_setkbptr]    := code_setkbptr        ;
  pJumpTable[ips_getPS]       := code_getps           ;
  pJumpTable[ips_setPS]       := code_setps           ;
  pJumpTable[ips_rp_loop]     := code_rp_loop         ;
  pJumpTable[ips_tr_loop]     := code_tr_loop         ;
  pJumpTable[ips_swap3]       := code_swap3           ;
  pJumpTable[ips_plus_store]  := code_plus_store      ;
  pJumpTable[ips__scode]      := code__scode          ;
  pJumpTable[ips__cscan]      := code__cscan          ;

// Initialize the Emulator workspace


  iPPC          := kSYSPAGE ;
  bIsOpen       := false    ;
  iINPUTPOINTER := kTV8     ;
  bInsertON     := false    ;

// Inner Interpretor Loop

  bOKToStop := false ;

  _20msCount := Do20msInterval ;

  repeat

// Command Dispatcher

{ emu }
    iHP := PeekCardinal(iPPC) ;
    iPPC := iPPC + 4 ;
{ exec }
    iCPC := PeekCardinal(iHP) ;
    iHP := iHP + 4 ;

    pJumpTable[Lo(iCPC)] ;
{ ret }

//  20ms Pseudo Interrupt Handler - Called every time for speed

    Dec(_20msCount) ;
    if (_20msCount=0) then begin
      code_uhr ;                // update time/stopwatches
      code_ipptrcheck ;         // block is ready to be processed ?
      code_keyb ;               // service keyboard
      code_file_in ;            // service file input
      if (UseDVFLAG) and (PeekCardinal(kDVFLAG)=1) then begin
        DrawTVScreen ;
      end ;
      _20msCount := Do20msInterval ;
      Application.ProcessMessages ;
      Sleep(1) ;
    end ;

// Keep going until Thread is terminated

  until (bOKToStop) ;

// Reset Running Flag

  bIsRunning := false ;

end ; { Execute }

procedure TfrmM3205.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  bOKToStop := true ;
end;

procedure TfrmM3205.mnuStartClick(Sender: TObject);
begin
  bOKToStop := true ;
  tmrStart.Enabled := true ;
end;

procedure TfrmM3205.mnuOptionsClick(Sender: TObject);
begin
  if frmOptions = nil then frmOptions := TfrmOptions.Create(Self) ;
  frmOptions.ShowModal ;
end;

procedure TfrmM3205.SetKernelFilename(const Value: string);
begin
  FKernelFilename := Value;
end;

procedure TfrmM3205.code_rp_loop ;
{
     RP-LOOP is only called by the library function R>P. You are
     unlikely to use this routine directly.
     Entry: 4 items on the stack: theta0, X, Y, 0
     Exit: 3 items on the stack: (theta0+atn2<X,Y>), k*X', ~0
     where k=1.6468. Routine rotates the vector <X,Y> clockwise through
     an angle such as to drive Y' to zero. The initial vector must
     lie in the right hand hemisphere; that is , X must be positive.
     The handler R>P ensures this.

     Input: theta0, X, Y, 0
     Output: (theta0 + atn2<X,Y>), k*SQR(X*X+Y*Y), 0
}

var
  X, Y, theta0 : integer ;
  Xrad, Yrad, trad, D, E : Extended ;

begin

//RP-LOOP
//  Input:   theta0, X, Y, 0
//  Output:  (theta0 + atn2<X,Y>), k*SQR(X*X+Y*Y), 0

   Y := PopInteger ;    //remove 0
   Y := PopInteger ;
   X := PopInteger ;
   theta0 := PopInteger ;

   Yrad := Y / 683565275.0 ;  //convert to radians
   Xrad := X / 683565275.0 ;
   trad := theta0 / 683565275.0 ;

   D := trad + ArcTan2(Yrad,Xrad) ;
   E := 1.6468 * sqrt(Xrad*Xrad + Yrad*Yrad) ;
   X := Trunc(D * 683565275.0 + 0.5) ;
   Y := Trunc(E * 683565275.0 + 0.5) ;

   PushInteger(X) ;
   PushInteger(Y) ;
   PushInteger(0) ;

end ; { code_rp_loop }

procedure TfrmM3205.code_tr_Loop;

{
     TR-LOOP is only called by the library function T-R. You are unlikely
     to use this routine directly.

     Entry: 4 items on the stack: theta, X, Y, 0
     Exit: 3 items on the stack: ~0, k*X', k*Y'
     where k=1.6468. Routine rotates the vector <X,Y> anti-clockwise
     through the angle theta. The angle theta must lie in the right
     hand hemisphere; that is, -90 <= theta <= +90. The handler T-R
     ensures this.

     Input: theta, X, Y, 0
     Output: 0, k*Cos(theta + atn2<X,Y>), k*Sin(theta + atn2<X,Y>)
}

var
  Y, X, theta : integer ;   // 2pi radians = #FFFFFFFF for X,Y,theta
  Yrad, Xrad, trad, F, R : Extended ;
begin

//TR-LOOP:
//  Input:   theta,  X, Y, 0
//  Output:  0,  k*Cos(theta + atn2<X,Y>),  k*Sin(theta + atn2<X,Y>)

  Y := PopInteger ;      // Remove 0
  Y := PopInteger ;
  X := PopInteger ;
  theta := PopInteger ;
  Yrad := Y / 683565275.0 ;  //convert to radians
  Xrad := X / 683565275.0 ;
  trad := theta / 683565275.0 ;
  R := Sqrt(Yrad*Yrad + Xrad*Xrad) ;
  F := trad + ArcTan2(Yrad,Xrad);
  X := Trunc(1.6468*R*Cos(F)*683565275.0 + 0.5);
  Y := Trunc(1.6468*R*Sin(F)*683565275.0 + 0.5);
  PushInteger(0);
  PushInteger(X);
  PushInteger(Y);

end ; { code_tr_loop }

procedure TfrmM3205.code_swap3 ;
{
    swap3 (3V3) swaps two triples on the stack.

    That is, a b c d e f -> d e f a b c

    Reference: Private Communication, James Miller, May 10, 2001
}

var
  Index : Cardinal ;
  Swap  : Cardinal ;

begin
  Index := iPSP ;
  while (Index<iPSP+12) do begin
    Swap := PeekCardinal(Index) ;
    PokeCardinal(Index,PeekCardinal(Index+12)) ;
    PokeCardinal(Index+12,Swap) ;
    Inc(Index,4) ;
  end ;
end ; { code_swap3 }

procedure TfrmM3205.SetDo20msInterval(const Value: Cardinal);
begin
  FDo20msInterval := Value;
end;

procedure TfrmM3205.SetForceClock(const Value: boolean);
begin
  FForceClock := Value;
end;

procedure TfrmM3205.SetUTCOffset(const Value: double);
begin
  FUTCOffset := Value;
end;

procedure TfrmM3205.tmrStartTimer(Sender: TObject);
begin
  tmrStart.Enabled := false ;
  Execute ;
end;

procedure TfrmM3205.Subtract64(N, M: Int64; var R: Int64);
{
     Subtract64 - Subtracts 2 unsigned 64 bit d-words (N & M) to
     form Unsigned 32 bit result (R=M-N).
}

var
  _N : packed array[0..7] of byte absolute N ;
  _M : packed array[0..7] of byte absolute M ;
  _R : packed array[0..7] of byte absolute R ;
  A  : byte ;
  B  : word ;
  C  : word ; { Borrow }
  D  : word ;

begin
  R := 0 ;
  C := 0 ;
  for A := 0 to 7 do begin
    D := _N[A] + C ;
    B := _M[A] ;
    if (B<D) then begin
      Inc(B,$100) ;
      C := 1 ;
    end
    else begin
      C := 0 ;
    end ;
    B := B - D ;
    _R[A] := B and $ff ;
  end ;
end ; { Subtract64 }

function TfrmM3205.Compare64(N, M: Int64): integer;

{

 64 bit Unsigned Comparison

 returns:

 -1 if N<M
 0 if N=M
 +1 if N>M
}

var
  iBit : Int64 ;
  nBit, mBit : Int64 ;
begin
  Result := 0 ;
  iBit := $8000000000000000 ;
  while (iBit<>0) do begin
    nBit := N and iBit ;
    mBit := M and iBit ;
    if (nBit<>0) and (mBit=0) then begin
      Result := +1 ;
      Exit ;
    end
    else if (nBit=0) and (mBit<>0) then begin
      Result := -1 ;
      Exit ;
    end ;
    iBit := iBit shr 1
  end ;
end { Compare64 } ;

procedure TfrmM3205.code_plus_store;
var
  iAddress : Cardinal ;
begin
  iAddress := PopCardinal ;
  PokeInteger(iAddress,PeekInteger(iAddress)+PopInteger) ;
end ; { code_plusstore }

procedure TfrmM3205.DrawTVScreen;
var
  iAddress : Cardinal ;
begin

  PokeCardinal(kDVFLAG,0) ;
  for iAddress := kTV0 to kTVE do begin
    DrawChar(iAddress) ;
  end ;

end ; { DrawTVScreen }

procedure TfrmM3205.code_cyc2 ;

{
     CYC2 takes a 16-bit seed and a byte and returns the
     crcc'd value. Typically used in a loop, e.g.
     #FFFF 0 511 JE I @B CYC2 NUN

     <seed> <byte> CYC2
     <new seed>

     NOTE: CRCC needs MSB sent first!
}

var
  OutChar : byte     ;
  Swap    : Cardinal ;

{
    Reference: Page 35. AMSAT-UK OSCAR 13 Operations And Technical Handbook
    Note: CRCC Seed is #FFFF
}

function  AMSAT_CRCC(CRCC:Word;OutChar:Byte):Word ;
var
  NN   : byte ;
  Ch   : Word ;
  Test : Word ;
begin
  Ch := OutChar shl 8 ;
  for NN := 0 to 7 do begin
    Test := (Ch xor CRCC) and $8000 ;
    CRCC := CRCC shl 1 ;
    Ch := Ch shl 1 ;
    if (Test<>0) then begin
      CRCC := CRCC xor $1021 ;
    end ;
  end ;
  result := CRCC ;
end ; { AMSAT_CRCC }

begin { code_cyc2 }
  OutChar := PopCardinal and $ff ;
  Swap := PopCardinal ;
  Swap := AMSAT_CRCC(Lo(Swap) shl 8 + Hi(Swap),OutChar) ;
  PushCardinal(Lo(Swap) shl 8 + Hi(Swap)) ;
end ; { code_cyc2 }

procedure TfrmM3205.SetUseDVFLAG(const Value: boolean);
begin
  FUseDVFLAG := Value;
end;

procedure TfrmM3205.DrawChar(iAddress: Cardinal) ;
var
  iXPos, iYpos : Cardinal ;
  pRect : TRect ;
  iValue   : byte ;
begin

  iValue := PeekByte(iAddress) ;
  iXPos := (iAddress - kTV0) mod 64 * 10 + 8 ;
  iYPos := (iAddress - kTV0) div 64 * 16 + 8 ;
  pRect.TopLeft.X := iXPos ;
  pRect.TopLeft.Y := iYPos ;
  pRect.BottomRight.X := iXPos + 9 ;
  pRect.BottomRight.Y := iYPos + 15 ;

  with imgTVScreen.Canvas do begin

// Check for Inverse Video request, indicated by bit 7 of byte

    if (iValue and $80 <> 0) then begin
      Brush.Color := kForeColour ;
      Font.Color  := kBackColour ;
    end
    else begin
      Brush.Color := kBackColour ;
      Font.Color  := kForeColour ;
    end ;

    FillRect(pRect);
    TextOut(iXPos,iYPos,Chr(iValue and $7f));

  end ;

end ; { DrawChar }

end.
