unit ufrmOptions;

(*
                M3205 - ufrmOptions
       (c) 2005 Paul C. L. Willmott, VP9MU

 This program is free software; you can redistribute it
 and/or modify it under the terms of the GNU General
 Public License as published by the Free Software
 Foundation; either version 2 of the License, or at
 your option, any later version.

 This program is distributed in the hope that it will
 be useful, but WITHOUT ANY WARRANTY; without even the
 implied warranty of MERCHANTABILITY or FITNESS FOR A
 PARTICULAR PURPOSE.  See the GNU General Public
 License for more details.

 You should have received a copy of the GNU General
 Public License along with this program; if not, write
 to the Free Software Foundation, Inc., 59 Temple
 Place, Suite 330, Boston, MA  02111-1307  USA

        Contact : pwillmott@northrock.bm
*)

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TfrmOptions = class(TForm)
    btnOK: TButton;
    lblFilename: TLabel;
    edtFilename: TEdit;
    btnOpen: TButton;
    dlgOpenFile: TOpenDialog;
    chkForceClock: TCheckBox;
    lblInterval: TLabel;
    edtInterval: TEdit;
    lblUTCOffset: TLabel;
    edtUTCOffset: TEdit;
    chkDirectVideoAccess: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmOptions: TfrmOptions;

implementation

uses ufrmM3205;

{$R *.dfm}

procedure TfrmOptions.FormShow(Sender: TObject);
begin
  edtFilename.Text := frmM3205.KernelFilename ;
  chkForceClock.Checked := frmM3205.ForceClock ;
  chkDirectVideoAccess.Checked := frmM3205.UseDVFLAG ;
  edtInterval.Text := IntToStr(frmM3205.Do20msInterval) ;
  edtUTCOffset.Text := FloatToStr(frmM3205.UTCOffset) ;
end;

procedure TfrmOptions.btnOKClick(Sender: TObject);
begin
  frmM3205.KernelFilename := edtFilename.Text ;
  frmM3205.ForceClock := chkForceClock.Checked ;
  frmM3205.UseDVFLAG := chkDirectVideoAccess.Checked ;
  frmM3205.Do20msInterval := StrToInt(edtInterval.Text)  ;
  frmM3205.UTCOffset := StrToFloat(edtUTCOffset.Text)  ;
  frmM3205.SaveSettings ;
  Close ;
end;

procedure TfrmOptions.btnOpenClick(Sender: TObject);
begin
  dlgOpenFile.InitialDir := edtFilename.Text ;
  dlgOpenFile.FileName := edtFilename.Text ;
  dlgOpenFile.Execute ;
  edtFilename.Text := dlgOpenFile.FileName ;
end;

end.
